Ruby - Bug #13491

MinGW 58400 - TestSocket_BasicSocket#test read write _nonblock
04/21/2017 03:16 PM - MSP-Greg (Greg L)

Status: Closed
Priority: Normal
Assignee:

Target version:

ruby -v: ruby 2.5.0dev (2017-04-21 trunk 58426) |Backport: 2.2: UNKNOWN, 2.3: UNKNOWN, 2.4:
[x64-mingw32] UNKNOWN

Description
The test TestSocket_BasicSocket#test _read_write_nonblock was recently add via 58400 / c32fc82.

On a MinGW build, it fails. The following change at line 197 allows a MinGW build to pass.

case r = ssock.read_nonblock (16384, buf, exception: false)
when String
next

when nil

break
else
= flunk "unexpected read_nonblock return: #{r.inspect}"
+ flunk "unexpected read_nonblock return: #{r.inspect}" unless set_nb

end while true

See GitHub PR 1595

History

#1 - 04/21/2017 05:08 PM - normalperson (Eric Wong)

Greg.mpls@gmail.com wrote:

The test TestSocket BasicSocket#test_read_write_nonblock was recently add via 58400 / c32fc82.
On a MinGW build, it fails. The following change at line 197 allows a MinGW build to pass.

case r = ssock.read_nonblock (16384, buf, exception: false)
when String

next
when nil

break
else
= flunk "unexpected read_nonblock return: #{r.inspect}"
+ flunk "unexpected read_nonblock return: #{r.inspect}" unless set_nb

end while true

Oops, but wouldn't checking for :wait_readable be more correct?
Can you try the following, instead?

diff --git a/test/socket/test_basicsocket.rb b/test/socket/test_basicsocket.rb
index Ob13a7f1af..4d11521e9e 100644

--- a/test/socket/test_basicsocket.rb

+++ b/test/socket/test_basicsocket.rb

@@ -193,6 +193,9 @@ def test_read_write_nonblock

next

when nil

break
https://github.com/ruby/ruby/blob/c32fc82d0ed8bcf0d6e4de8518bbb7bd808a69b8/test/socket/test_basicsocket.rb#L197
https://github.com/ruby/ruby/pull/1595
mailto:Greg.mpls@gmail.com
https://bugs.ruby-lang.org/projects/ruby-trunk/repository/revisions/58400/diff
https://github.com/ruby/ruby/commit/c32fc82d0ed8bcf0d6e4de8518bbb7bd808a69b8
https://github.com/ruby/ruby/blob/c32fc82d0ed8bcf0d6e4de8518bbb7bd808a69b8/test/socket/test_basicsocket.rb#L197

else
flunk "unexpected read_nonblock return: #{r.inspect}"
end while true

Thanks.

#2 - 04/21/2017 08:42 PM - normalperson (Eric Wong)

Can you try r584377? | made it call I0.select on :wait_readable
instead of using your change.
Thanks.

#3 - 04/21/2017 09:00 PM - MSP-Greg (Greg L)

normalperson (Eric Wong) wrote:

Can you try r58437?

Works. | guess | was staring at the case statement, | should have added the test for :wait_readable. | tried 10.select, but | left of the timeout...

Thank you. I'll close the PR and this can be closed.

#4 - 04/22/2017 03:50 AM - usa (Usaku NAKAMURA)
- Status changed from Open to Closed

| got same error, too.
And it seems that r58437 has fixed it.
| still doubt that there is something wrong with 10#read_nonblock on Windows, but, about this issue, can be closed.

#5 - 04/22/2017 04:08 AM - normalperson (Eric Wong)
usa@garbagecollect.jp wrote:

| got same error, too.
And it seems that r58437 has fixed it.
| still doubt that there is something wrong with 10#read_nonblock on Windows, but, about this issue, can be closed.

Nothing wrong, just different behavior and | was sloppy.
| have encountered similar socket behavior differences before,
even between Linux and *BSD.
